#include "engine.hpp"

void Engine::run()
{
  do
  {
    section[partindex]->reset();
    int message=section[partindex]->run();
    int newpartindex=control(partindex,message);

    //need this for continuity of mouse movement...
    //alternatively could have input class somewhere, but this will do for now
    if (newpartindex>=0)
    {
        section[newpartindex]->mx=section[partindex]->mx;
        section[newpartindex]->my=section[partindex]->my;
        section[newpartindex]->mb1=section[partindex]->mb1;
    }
    partindex=newpartindex;
  }
  while (partindex>=0);
}

Engine::Engine():
partindex(0)
{

  timer = new Timer;
  soundengine = new SoundEngine;
  graphicsengine = new GraphicsEngine;
}

Engine::~Engine()
{
  delete timer;
  delete soundengine;
  delete graphicsengine;
  std::cout<<"Exited cleanly"<<std::endl;
}

