#include "enginepart.hpp"

EnginePart::~EnginePart()
{

}

int EnginePart::run()
{
    while(true)
    {
        timer->start();

        SDL_Event event;

        int message;

        while( SDL_PollEvent( &event ) )
        {
            //update mouse
          Uint8 a=SDL_BUTTON(SDL_GetMouseState(&mx, &my));
          mb1=a==SDL_BUTTON_LEFT;

          mb2=false;

          if (event.type==SDL_MOUSEBUTTONDOWN)
          {
            if (event.button.button==SDL_BUTTON_RIGHT)
            {
                mb2=true;
            }
          }

          message=input(event);
          if (message!=0)
            return message;
        }

        message=logic();
        if (message!=0)
          return message;

        draw();
        graphicsengine->flip();

        if( timer->get_ticks() < 1000 / FRAMES_PER_SECOND )
        {
            SDL_Delay( ( 1000 / FRAMES_PER_SECOND ) - timer->get_ticks() );
        }
    }

    return 0;
}

EnginePart::EnginePart(const SubengineInterface* subengines)
{
  timer=subengines->timer;
  graphicsengine=subengines->graphicsengine;
  soundengine=subengines->soundengine;
}
