#include "graphicsheader.hpp"

#ifndef __APPLE__

PFNGLBINDBUFFERARBPROC glBindBufferARB = NULL;
PFNGLGENBUFFERSARBPROC glGenBuffersARB = NULL;
PFNGLBUFFERDATAARBPROC glBufferDataARB = NULL;
PFNGLDELETEBUFFERSARBPROC glDeleteBuffersARB = NULL;

bool		g_fVBOSupported = false;      // ARB_vertex_buffer_object supported?
float		g_flYRot = 0.0f;              // Rotation
int		g_nFPS = 0, g_nFrames = 0;      // FPS and FPS Counter
DWORD		g_dwLastFPS = 0;              // Last FPS Check Time
#endif

bool IsExtensionSupported( char* szTargetExtension )
{
	const unsigned char *pszExtensions = NULL;
	const unsigned char *pszStart;
	unsigned char *pszWhere, *pszTerminator;

	// Extension names should not have spaces
	pszWhere = (unsigned char *) strchr( szTargetExtension, ' ' );
	if( pszWhere || *szTargetExtension == '\0' )
		return false;

	// Get Extensions String
	pszExtensions = glGetString( GL_EXTENSIONS );

	// Search The Extensions String For An Exact Copy
	pszStart = pszExtensions;
	for(;;)
	{
		pszWhere = (unsigned char *) strstr( (const char *) pszStart, szTargetExtension );
		if( !pszWhere )
			break;
		pszTerminator = pszWhere + strlen( szTargetExtension );
		if( pszWhere == pszStart || *( pszWhere - 1 ) == ' ' )
			if( *pszTerminator == ' ' || *pszTerminator == '\0' )
				return true;
		pszStart = pszTerminator;
	}
	return false;
}

void CMesh :: LoadHeightmap( )
{

  	m_nVertexCount = (int) 4;
    m_pVertices  = new CVert[m_nVertexCount];				// Allocate Tex Coord Data

    m_pVertices[0].x = 1.1;
		m_pVertices[0].y = 1.1;

    m_pVertices[1].x = -1.1;
		m_pVertices[1].y = 1.1;

    m_pVertices[2].x = -1.1;
		m_pVertices[2].y = -1.1;

    m_pVertices[3].x = 1.1;
		m_pVertices[3].y = -1.1;

		pointcount=0;
		indexcount=0;

}

void CMesh :: BuildIndexArray()
{
	
#ifndef __APPLE__

  glDeleteBuffersARB(1, &m_nVBOIndices);

    glGenBuffersARB(1, &m_nVBOIndices);
    glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER, m_nVBOIndices);
    glBufferDataARB(GL_ELEMENT_ARRAY_BUFFER, indexcount * sizeof(unsigned int), indexarray, GL_DYNAMIC_DRAW);
#endif
}


void CMesh :: BuildVBOs()
{
#ifndef __APPLE__
	
  glDeleteBuffersARB(1, &m_nVBOVertices);

	// Generate And Bind The Vertex Buffer
	glGenBuffersARB( 1, &m_nVBOVertices );					// Get A Valid Name
	glBindBufferARB( GL_ARRAY_BUFFER_ARB, m_nVBOVertices );			// Bind The Buffer
	// Load The Data
	glBufferDataARB( GL_ARRAY_BUFFER_ARB, pointcount*2*sizeof(float), pointarray, GL_STATIC_DRAW_ARB );

// Our Copy Of The Data Is No Longer Necessary, It Is Safe In The Graphics Card
	//delete [] m_pVertices; m_pVertices = NULL;
#endif

}

/*

 to destructor
 */
