#include "mainpart.hpp"

/*


 TODO: check conditions for integer population (blah...cast before checking...)


TODO LIST
DONE 1: commas
DONE 2: right click to remove endpoint
DONE 3: modify tutorial to reflect above
DONE 4: undo button
DONE 5: add credits to readme file
DONE 6: add sdl_Readme.txt
DONE 7: clear button
DONE 8: total population display
DONE 9: square root cities

PHOTO CREDITS

beardguy
http://www.flickr.com/photos/9805252@N03/3260805673
http://www.flickr.com/photos/iditnarkis/

other dude
http://www.flickr.com/photos/72825507@N00/3251912179

//TODO: shoudl have generic migration move people in proportion to the total population
//TODO: have path whiteness depend on number of people migrating
//TODO: display goal at last frame
//TODO: have light rects to indicate number of migration routes at any one time
//TODO:  directional arrows/ animated textures
//TODO:  if you try to add an arrow at the same time as you have removed one, it doesn't work (changing an inequality to an equality should fix it, but maybe there's a better way? (if there's equality, then remove the off one?, and if there's an on one remove the other one?))
//TODO:  hold shift to turn off point selection
//TODO:  right click and drag on lines to change migration speed
//TODO: treat off the same as other arrows
//TODO: mark cities with crosses, regardless of size
//TODO: multiple populations
//TODO: could do a blur effect for the replay?  (Or would that be to ID? >_<  )
//TODO: multiple line types
//TODO: arrow types: include direction, and off, as types
//TODO: deal with adding an event directly over an 'off'  command for the same edge
//TODO: have space click 'submit' button at bottom (if it's enabled of course)
//TODO: have 'esc' skip to game if you are on briefing summary screen, or skip to quit if you are there otherwise

oh have textures be the width of the screen diagonal? (can probably have them low res as well)

  CAPTURING: don't allow change of focus unless mouse button is up

  LEVEL IDEAS

  one that favours moving through several cities rather than taking the direct route (mortality rate dependant on distance?)
*/


Arrow_Type inttoatype(int a)
{
    switch (a)
    {
    case 0:
        return at_both;
    case 1:
        return at_player;
    case 2:
        return at_enemy;
    case 3:
        return at_remove;
    }
    //shouldn't get here!
    return at_both;
}

void toggle1(int& param, bool& b)//MENU
{
    b=!b;
}
void toggle2(int& param, bool& b)
{
    param=0;
}
void toggle3(int& param, bool& b)
{
    param=1;
}
void toggle4(int& param, bool& b)
{
    param=2;
}
void toggle5(int& param, bool& b)//level complete
{
    b=!b;
}

void setfunction(int& param, bool& b)//should use for generic toggling
{
    b=true;
    param=1;
}

MainPart::MainPart(SubengineInterface* subengines, Global_Variables* p_global_variables):
        EnginePart(subengines)
{
    global_variables=p_global_variables;
    widgets.push_back(new Set_Button(7,480-340-23,28,24,graphicsengine->iconrenderer,0,"menu",true,&setfunction,showmenu,0));
    widgets.push_back(new Set_Button(50,480-340-23,28,24,graphicsengine->iconrenderer,1,"homogeneous migration",true,&toggle2,newarrowmode,1));
    widgets.push_back(new Set_Button(80,480-340-23,28,24,graphicsengine->iconrenderer,2,"flight",true,&toggle3,newarrowmode,0));
    widgets.push_back(new Set_Button(110,480-340-23,28,24,graphicsengine->iconrenderer,3,"purge",true,&toggle4,newarrowmode,0));
    widgets.push_back(new Text_Button(200,480-320-23,graphicsengine->fontrenderer,"submit thesis","submit finished work to committee",false,&toggle3,submitparam,0));
    widgets.push_back(new Text_Button(160,480-288,graphicsengine->fontrenderer,"continue","continue research",false,&toggle3,menuparam,0));
    widgets.push_back(new Text_Button(421,480-288,graphicsengine->fontrenderer,"quit","quit to menu",false,&toggle4,menuparam,0));
    widgets.push_back(new Text_Button(315,480-288,graphicsengine->fontrenderer,"reset","reset",false,&toggle3,restartparam,0));
    widgets.push_back(new Set_Button(605,480-340-23,28,24,graphicsengine->iconrenderer,4,"undo",true,&toggle3,doundo,0));

    reset();
    capturing=NULL;
}

MainPart::~MainPart()
{

}

void MainPart::reset()
{
    mousemode=mm_default;
    highlighted=-1;
    highlightedarrow=-1;
    draglineselected=-1;
    cutscenemarker=0;
    previouslyreleased=true;
    dragmode=false;
    populate();
    arrows.clear();
    events.clear();
    famines.clear();

    calcSlices();

    setTime(0);
    calcArrows(arrows,0);
    calcFamines(famines,0);
    focus=0;
//    graphicsengine->g_pMesh->pointarray=&this->points[0].x;
//    graphicsengine->g_pMesh->pointcount=this->points.size();
//    graphicsengine->g_pMesh->BuildVBOs();
    levelmode=lm_intro;


    //set up arrows
    widgets[1]->on=false;
    widgets[2]->on=false;
    widgets[3]->on=false;

    widgets[1]->enabled=global_variables->leveldata->enabledarrows.both;
    widgets[2]->enabled=global_variables->leveldata->enabledarrows.player;
    widgets[3]->enabled=global_variables->leveldata->enabledarrows.enemy;

    if (widgets[1]->enabled)
    {
        widgets[1]->on=true;
        arrowmode=0;
    }
    else if (widgets[2]->enabled)
    {
        widgets[2]->on=true;
        arrowmode=1;
    }
    else
    {
        widgets[2]->on=true;
        arrowmode=2;
    }
    newarrowmode=arrowmode;
    showmenu=0;
    menuparam=0;
    submitparam=0;
    restartparam=0;
    doundo=false;
    widgets[0]->on=false;
    widgets[4]->enabled=false;
    widgets[5]->enabled=false;
    widgets[6]->enabled=false;
    widgets[7]->enabled=false;
    widgets[8]->enabled=false;

    capturing=NULL;
    while (!backups.empty())
    {
        backups.pop();
    }

}

void MainPart::updatearrowindices()
{

//    graphicsengine->g_pMesh->indexarray=&this->arrows[0].a;
//    graphicsengine->g_pMesh->indexcount=2*this->arrows.size();
//    graphicsengine->g_pMesh->BuildIndexArray();

}


/*

    deletes an end-point after the current time
*/
void MainPart::deleteEndAfter(const Arrow& a)
{

    set<Event>::iterator i=events.begin();
    while (i!=events.end())
    {
        if (i->t>time)
        {
            if (overlap(a,*i))
            {
                if (i->atype==at_remove)
                {
                    events.erase(i);
                }
                return;
            }
        }
        ++i;
    }
}


/*

  Delete event at or to the left of current time.
  If there is an event prior to that, in the same position THAT IS NOT AN OFF, then quit.
  OTHERWISE, see if there is an off to the right, and remove it
*/

void MainPart::deleteArrowEvent(const Arrow& a, float t)
{
    //deletes an arrow enclosed at a certain time
    //there can only be one type of arrow at any given location, so make type-agnostic
    {

        set<Event>::iterator i=events.begin();
        while (i!=events.end())
        {
            if (i->t>=time)
            {
                if (overlap(a,*i))
                {
                    if (i->atype==at_remove)
                    {
                        events.erase(i);
                        break;
                    }
                    else if (i->atype==a.atype && i->a==a.a && i->b==a.b)
                    {
                        events.erase(i++);
                    }
                    else
                    {
                        //not sure about this line
                        break;
                    }

                }
                else
                    ++i;

            }
            else
                ++i;
        }
    }

    {
        set<Event>::reverse_iterator i;
        for (i=events.rbegin();i!=events.rend();i++ )
        {
            if (i->t<=time)
            {
                if (overlap(a,*i))
                {
                    GLfloat starttime=i->t;
                    events.erase(--i.base());
                    set<Event>::reverse_iterator j;
                    for (j=events.rbegin();j!=events.rend();j++)
                    {
                        //if there is no non-off event directly before, then erase it, OTHERWISE
                        // set it to zero
                        if (j->t<starttime && overlap(*i,*j))
                        {
                            if (j->atype!=at_remove)
                            {
                                events.insert(Event(starttime,j->a,j->b,at_remove));
                            }
                            else
                            {
                                return;
                            }
                        }
                    }
                    //if you get to the start without finding anything, just erase it
                    return;

                }
            }
        }
    }
}

//if an event is repeated at or after time t, delete it
void MainPart::deleteRepetitionsAfter(const Arrow& a)
{
    set<Event>::iterator i=events.begin();
    while (i!=events.end())
    {
        if (i->t>=time)
        {
            if (overlap(a,*i))
            {
                if (same(a,*i))
                {
                    events.erase(i++);
                    calcSlices();
                    return;
                }
                else//otherwise a new event is starting at this position, so finish
                {
                    return;
                }
            }
            else
                ++i;
        }
        else
            ++i;
    }

}


//return true if there was an item deleted
bool MainPart::tryDelete(int a, int b)
{
    //1: create set of events before or at the current time in the given arrow
    return true;
}


////CAN THE FOLLOWING EVEN BE CALLED?
const bool MainPart::isAlreadyOff(const Arrow& a) const
{
    /*
     have to go to current time, then work back until either
     1: find a STOP (return true),
     2: find a START (return false)
     3: get to begining (return true)

       */

    set<Event>::reverse_iterator i;
    for (i=events.rbegin();i!=events.rend();i++ )
    {
        if (i->t<=time)
        {
            if (overlap(a,*i) )
            {
                if (i->atype==at_remove)
                {
                    return true;
                }
                else
                {
                    return false;
                }

            }
        }
    }

    return true;
}

////CAN THE FOLLOWING EVEN BE CALLED?
const bool MainPart::isAlreadyValue(const Arrow& a) const
{
    /*
     have to go to current time, then work back until either
     1: find a STOP (return true),
     2: find a START (return false)
     3: get to begining (return true)

       */

    set<Event>::reverse_iterator i;
    for (i=events.rbegin();i!=events.rend();i++ )
    {
        if (i->t<=time)
        {
            if (overlap(a,*i) )
            {
                if (i->atype==a.atype)
                {
                    return true;
                }
                else
                {
                    return false;
                }

            }
        }
    }

    return true;
}


//Used in arrow deletion; type-agnostic
const bool MainPart::startedAt(const Arrow& a) const
{

    set<Event>::iterator i;
    for (i=events.begin();i!=events.end();i++ )
    {
        if (i->t==time)
        {
            if (overlap(a,*i)&&(i->atype!=at_remove))
            {
                return true;
            }
        }
    }

    return false;
}

// returns -1 if nothing
const int MainPart::atype_before(const Arrow& a) const
{

    set<Event>::reverse_iterator i;
    for (i=events.rbegin();i!=events.rend();i++ )
    {
        if (i->t<time)
        {
            if (overlap(a,*i))
            {
                return (i->atype);
            }
        }
    }

    return -1;
}

//TYPE-AGNOSTIC
void MainPart::deleteEnd(const Arrow& a)
{

    set<Event>::iterator i;
    for (i=events.begin();i!=events.end();i++ )
    {
        if (i->t==time)
        {
            if (overlap(a,*i))
            {
                events.erase(i);
                return;
            }
        }
    }
}
const bool MainPart::isAlreadyOn(const Arrow& a) const
{
    /*
    have to go to current time, then work back until either
    1: find a STOP (return false),
    2: find a start (return true)
    3: get to begining (return false)

      */

    set<Event>::reverse_iterator i;
    for (i=events.rbegin();i!=events.rend();i++ )
    {
        if (i->t<=time)
        {
            if (overlap(a,*i) )
            {
                if (same(a,*i))
                {
                    return true;
                }
                else
                {
                    return false;
                }

            }
        }
    }

    return false;
}


void MainPart::highlightCity()
{
    float curclosest=100;

    for (unsigned int i = 0; i < points.size(); i++)
    {
        float x = points[i].x - mx;
        float y = points[i].y - my;
        float d = x * x + y * y;
        if (d < 3*36 && d < curclosest)
        {
            curclosest = d;
            highlighted = i;
        }
    }
}

void MainPart::calcHighlightInterval()
{
    /*
      do two sweeps; one forward to determine the end point, one back to determine the start.

      rather suboptimal, and given how frequently it's being calculated, probably should
      deal with it. (or call it less)
    */
    //first go forwards, determine end-point
    {
        highlightedarrowend=-1;
        set<Event>::iterator i;
        for (i=events.begin(); i!=events.end();i++)
        {
            if (i->t>=time)
            {
                if (overlap(arrows[highlightedarrow],*i)
                        &&(!same(arrows[highlightedarrow],*i)))//need this if you placed something at the current time
                {
                    // shouldn't need to check i->add if things are going correctly; maybe add an Assert here?
                    highlightedarrowend=i->t;
                    break;
                }
            }
        }
        if (highlightedarrowend<0)
            highlightedarrowend=1.0f;
    }

    //go back and determine starting-point
    {
        set<Event>::reverse_iterator i;
        for (i=events.rbegin(); i!=events.rend();i++)
        {
            if (i->t<=time)
            {
                if (same(arrows[highlightedarrow],*i))
                {
                    // shouldn't need to check i->add if things are going correctly; maybe add an Assert here?
                    highlightedarrowbegin=i->t;
                    break;
                }
            }
        }
    }
}

void MainPart::highlightArrow()
{
    float curclosest=100;

    for (unsigned int i = 0; i < arrows.size(); i++)
    {
        float d = distfromlinesq(points[arrows[i].a].x, points[arrows[i].a].y, points[arrows[i].b].x, points[arrows[i].b].y, mx, my);
        if (d < 3*26 && d < curclosest)
        {
            curclosest = d;
            highlightedarrow = i;
        }
    }

    if (highlightedarrow>=0)
    {
        calcHighlightInterval();
    }

}

void MainPart::playInput()
{


    if (mousemode==mm_default)
    {
        if (capturing==NULL)
        {
            //statustext=nulltext;
            foreach (Screen_Element* el, widgets)
            {
                if (el->isat(mx,480-my) && el->enabled)
                {
                    //statustext=el->tooltip;
                    el->mouseinput(mx,480-my,mb1);
                    capturing=el;
                    el->focused=true;
                    break;
                }
                else
                    el->focused=false;
            }
        }
        else
        {
            if (capturing->isat(mx,480-my))
            {
                capturing->mouseinput(mx,480-my,mb1);
            }
            else if (!mb1)
            {
                capturing->uncapture();
                capturing=NULL;
            }
        }
    }

    highlighted = -1;
    highlightedarrow = -1;

    // part 1: deal with focus, ONLY IF NO BUTTONS ALREADY FOCUSSED
    if (!mb1)
    {
        if (my<=PLAY_HEIGHT)
            focus=0;//play area
        else if (my>=456)
            focus=2;//status bar
        else if (mx<151)
            focus=3;//information panel
        else
            focus=1;//timeline
    }

    switch (focus)
    {
    case 0:
    {
        switch (mousemode)
        {
        case mm_default:
        {
            //STUFF THAT DOESN'T CHANGE THE MOUSEMODE
            //step 1: see if there's anything to select

            //cities get precedence:
            highlightCity();

            //then lines
            if (highlighted < 0)             //if no point selected, look for line segments to intersect
                highlightArrow();

            //STUFF THAT POTENTIALLY DOES CHANGE THE MOUSEMODE


            if (mb1)
            {
                if (highlighted >= 0)                 //if you click on a point
                {
                    dragsource = highlighted;
                    mousemode = mm_dragpoint;
                }
                else if (highlightedarrow >= 0)                 //otherwise if you click on a line
                {
                    draglineselected = highlightedarrow;
                    mousemode = mm_dragline;
                }
            }

            if (mb2)//mb2 only detects click actions...apple compatibility thing
            {
                if (highlightedarrow>=0)
                {
                    backupEvents();
                    deleteEndAfter(arrows[highlightedarrow]);
					calcSlices();
                }
            }
        }
        break;

        case mm_dragpoint:
        {
            highlightCity();

            if (!mb1)
            {
                if (highlighted >= 0 && (highlighted != dragsource))
                {
                    //if the arrow changes type here
                    //if the arrow was the same type before, just delete it
                    //if it was a different one, then replace it with the new one
                    if (startedAt(Arrow(dragsource,highlighted,arrowmode)))
                    {
                        backupEvents();
                        if (atype_before(Arrow(dragsource,highlighted,arrowmode))==arrowmode)
                        {
                            deleteEnd(Arrow(dragsource,highlighted,arrowmode));

                        }
                        else
                        {
                            deleteEnd(Arrow(dragsource,highlighted,arrowmode));
                            if (!isAlreadyOn(Arrow(dragsource,highlighted,arrowmode)))
                            {
                                Event e=Event(getTime(), dragsource, highlighted,arrowmode);
                                deleteRepetitionsAfter(e);
                                events.insert(e);
                            }
                        }
                        calcArrows(arrows,time);
                        calcFamines(famines,time);
                        calcSlices();
                    }
                    //if it doesn't already  exist, create it
                    else if (!isAlreadyOn(Arrow(dragsource,highlighted,arrowmode)))
                    {
                        backupEvents();
                        deleteEnd(Arrow(dragsource,highlighted,arrowmode));
                        Event e=Event(getTime(), dragsource, highlighted,arrowmode);
                        deleteRepetitionsAfter(e);
                        if (!isAlreadyOn(Arrow(dragsource,highlighted,arrowmode)))
                        {
                            events.insert(e);
                        }
                        calcArrows(arrows,time);
                        calcFamines(famines,time);
                        calcSlices();
                    }
                }
                else
                {
                    //have, essentially, clicked on a city    - do something here, then!
                }
                mousemode=mm_default;
            }
        }
        break;

        case mm_dragline:
        {
            highlightArrow();

            if (!mb1)
            {


                if (highlightedarrow==draglineselected)
                {
                    if (!isAlreadyOff(arrows[draglineselected])) //with capturing, this isn't necessary I think?
                    {
                        backupEvents();
                        //if you try to stop a path that was created at the time of it's deletion, then remove it
                        if (startedAt(arrows[draglineselected]))
                        {
                            //CAREFUL ABOUT THIS USAGE AS OF ATYPE INTRO
                            //type is irrelevant
                            Event e=Event(getTime(), arrows[draglineselected].a, arrows[draglineselected].b,at_remove);

                            events.erase(e);
                            deleteRepetitionsAfter(e);
                            if (!isAlreadyValue(e))
                            {
                                events.insert(e);
                            }

                            //       deleteArrowEvent(arrows[draglineselected], time);

                        }
                        else
                        {
                            //otherwise insert the endpoint
                            Event e=Event(getTime(), arrows[draglineselected].a, arrows[draglineselected].b,at_remove);
                            deleteRepetitionsAfter(e);
                            events.insert(e);

                        }
                    }
                }
                else
                {
                    backupEvents();


                    if (startedAt(arrows[draglineselected]))
                    {
                        //CAREFUL ABOUT THIS USAGE AS OF ATYPE INTRO
                        //type is irrelevant

                        Event e=Event(getTime(), arrows[draglineselected].a, arrows[draglineselected].b,at_remove);

                        events.erase(e);
                        deleteRepetitionsAfter(e);
                        if (!isAlreadyValue(e))
                        {
                            events.insert(e);
                        }

                    }
                    else
                    {
                        //DELETE LAST EVENT TO THE LEFT, and if there are no move events to the left before, remove an OFF to the right, if there was one
                        deleteArrowEvent(arrows[draglineselected], time);
                    }
                }

                calcArrows(arrows,time);
                calcFamines(famines,time);
                calcSlices();
                highlightedarrow=-1;
                mousemode=mm_default;
            }
        }
        break;
        }
    }
    break;
    case 1:
    {
        if (mousemode==mm_default && mb1)
        {
            //SHOULD PROBABLY DISCONNECT(widget related stuff from above) STUFF HERE ALSO
            float newtime=max(min((((float)mx)-167.0f)/(629.0f-167.0f),1.0f),0.0f);
            setTime(newtime);
        }
    }
    break;
    default:
        break;
    }

    //determine tooltip (could integrate with previous switch)
    switch (focus)
    {
    case 0:
        if (capturing!=NULL)
        {
            tooltip=capturing->tooltip;
        }
        else
        {
            if (highlighted>=0)
            {
                tooltip="city";
            }
            else if (highlightedarrow>=0)
            {
                tooltip="migration route";
            }
            else
            {
                tooltip="map view";
            }
        }
        break;
    case 1:
        tooltip="timeline";
        break;
    case 2:
        tooltip="status bar";
        break;
    case 3:
        tooltip="information panel";
        break;
    case 4:
        break;
    }
}

int MainPart::input(const SDL_Event& event)
{
    switch (event.type)
    {
    case SDL_QUIT:
        return -1;
        break;
    case SDL_KEYDOWN:
    {
        switch ( event.key.keysym.sym )
        {
        case SDLK_ESCAPE:
            if (levelmode==lm_intro)
            {
                cutscenemarker=0;
                setMenu();//show objective
                previouslyreleased=true;
                widgets[6]->enabled=false;//hide quit button
                widgets[7]->enabled=false;
            }
            else if (levelmode==lm_playback)
            {
                setTime(0);
            }
            else if (levelmode==lm_outro)
            {
                if (global_variables->level==global_variables->maxlevel && global_variables->maxlevel<20)
                {
					global_variables->level++;
                    global_variables->maxlevel++;
                }

                //OPTIONALLY, PUT A LEVEL STATS SCREEN NEXT
                return 1;//FINISHED LEVEL
            }
            else
            {
                if (levelmode==lm_menu)
                {
                    widgets[0]->on=false;
                    widgets[5]->enabled=false;
                    widgets[6]->enabled=false;
                    widgets[7]->enabled=false;
                    levelmode=lm_game;
                    calcSlices();//called again to enable 'submit thesis' button, if level auto-completed
                }
                else
                    return 3;
            }
            break;
			case SDLK_t:
			{
				std::cout<<getTime()<<endl;
			}
			break;
        default:
            break;
        }
    }
    }


//   enum LevelMode {lm_intro, lm_game, lm_menu,lm_playback,lm_outro} levelmode;

    switch (levelmode)
    {
    case lm_intro:
    {
        if (previouslyreleased && mb1)//clickedy!
        {
            //progress intro
            cutscenemarker++;
            if (cutscenemarker>=global_variables->leveldata->intro.size())
            {
                //if finished progression, thengo to game
                cutscenemarker=0;
                setMenu();//show objective
                widgets[6]->enabled=false;//hide quit button
                widgets[7]->enabled=false;//hide quit button
            }
        }
    }
    break;
    case lm_game:
    {
        playInput();
    }
    break;
    case lm_menu:
    {
        //check if button pressed first, otherwise:
        //OR MAYBE HAVE TWO BUTTONS AND A LISTENER? ONE TO QUIT, ONE TO RETURN <- SOUNDS BETTER

        if (capturing==NULL)
        {
            //statustext=nulltext;
            for (unsigned int i=5;i<8;i++)
            {
                if (widgets[i]->isat(mx,480-my) && widgets[i]->enabled)
                {
                    //statustext=el->tooltip;
                    widgets[i]->mouseinput(mx,480-my,mb1);
                    capturing=widgets[i];
                    widgets[i]->focused=true;
                    break;
                }
                else
                    widgets[i]->focused=false;
            }
        }
        else
        {
            if (capturing->isat(mx,480-my))
            {
                capturing->mouseinput(mx,480-my,mb1);
            }
            else if (!mb1)
            {
                capturing->uncapture();
                capturing=NULL;
            }
        }

    }
    break;
    case lm_playback:
    {
    }
    break;
    case lm_outro:
    {
        //should be same as lm_intro, more or less
        if (previouslyreleased && mb1)//clickedy!
        {
            //progress intro
            cutscenemarker++;
            if (cutscenemarker>=global_variables->leveldata->outro.size())
            {
                //FINISHED LEVEL

                if ((global_variables->level==global_variables->maxlevel) && (global_variables->maxlevel<19))
                {
                    global_variables->level++;
                    global_variables->maxlevel++;
                }

                //OPTIONALLY, PUT A LEVEL STATS SCREEN NEXT
                return 1;//FINISHED LEVEL
            }
        }
    }
    break;

    }

    //FIRST SEE IF BUTTONS CAPTURE ANYTHING

    previouslyreleased = !mb1;

    return 0;
}

//a replacement for equality; checks whether one arrow should interrupt another
bool overlap(const Arrow& a, const Arrow&b)
{
    return  (a.a==b.a && a.b==b.b)|| (a.a==b.b && a.b==b.a);
}

bool same(const Arrow& a, const Arrow&b)
{
    if (a.atype==at_remove)
    {
        return (((a.a==b.a && a.b==b.b)|| (a.a==b.b && a.b==b.a)) && a.atype==b.atype);
    }
    else
    {
        return  (a.a==b.a && a.b==b.b && a.atype==b.atype);
    }
}

const int MainPart::arrowtypeat(Arrow a,const vector<Arrow>& arrs ) const
{
    foreach(Arrow b, arrs)
    {
        if (overlap(a,b))
            return b.atype;
    }

    return -1;
}

void MainPart::calcFamines(vector<FamineData>& fams, float t)
{
    fams.clear();
    foreach(Famine e, global_variables->leveldata->famines)
    {
        if (e.a<=t && e.b>=t)
        {
            fams.push_back(FamineData(e.city,e.rate));
        }
    }

}


void MainPart::calcArrows(vector<Arrow>& arrs, float t)
{

    arrs.clear();
    foreach(Event e, events)
    {

        Arrow a = Arrow(e.a, e.b,e.atype);
        if (e.t > t)
            break;

        //  int existingtype=arrowtypeat(a,arrs);

        for (unsigned int i = 0; i < arrs.size(); i++)
        {
            if (overlap(a,arrs[i]))
            {
                arrs.erase(arrs.begin() + i);
                i--;
            }
        }

        if (inttoatype(a.atype)!=at_remove)
        {
            arrs.push_back(a);
        }
    }

    updatearrowindices();

}


void MainPart::setTime(float d)
{
    if (d>1)
        d=1;
    else if (d<0)
        d=0;

    time = d;
    calcArrows(arrows,time);
    calcFamines(famines,time);
    populations=slices[(int) (time*((float)SLICECOUNT))]->populations;
    //SQUARE ROOT HERE
    totalpops.a=slices[(int) (time*((float)SLICECOUNT))]->totalpops.a;
    totalpops.b=slices[(int) (time*((float)SLICECOUNT))]->totalpops.b;
}

const float MainPart::getTime() const
{
    return time;
}

void MainPart::setMenu()
{
    levelmode=lm_menu;
    menuparam=0;
    if (capturing!=NULL)
    {
        capturing->focused=false;
        capturing=NULL;
    }
    widgets[5]->enabled=true;
    widgets[6]->enabled=true;
    widgets[7]->enabled=true;
    showmenu=0;
}

void MainPart::calcSlices()
{

    //step 1: empty slice vector
    if (slices.size()==0)
    {
        foreach(Slice* s, slices)
        {
            delete s;
        }
    }
    slices.clear();

    //step 2 initialize first slice.

    {
        Slice* s = new Slice();

        s->populations = startingpopulations;
        s->arrows.clear();
        calcArrows(s->arrows,0);
        calcFamines(s->famines,0);
        float pop0=0;
        float pop1=0;
        for (int i=0;i<citycount;i++)
        {
            pop0+=s->populations[i].a;
            pop1+=s->populations[i].b;
        }
        s->totalpops.a=pop0;
        s->totalpops.b=pop1;
        slices.push_back(s);
    }

    //step 3 start the iteration
    for (int i=1;i<=SLICECOUNT;i++)
    {
        Slice* s = new Slice();
        s->populations=slices[i-1]->populations;

        //take arrows into account;

        //doing this iteratively isn't great; it gives privilege to the ordering of cities;
        //only *really* matters when population is tiny though, or lots of immigration, so
        //doesn't matter tooo mcuh
        foreach(Arrow a, slices[i-1]->arrows)
        {
            //move 0.02 people from a.a to a.b
            if (a.atype==at_player || a.atype==at_both)
            {
                float f = min (global_variables->leveldata->profiles[0].migrationspeed/distancesq[a.a][a.b],s->populations[a.b].a);
                s->populations[a.a].a+=f;
                s->populations[a.b].a-=f;
            }
            if (a.atype==at_enemy || a.atype==at_both)
            {
                float g = min (global_variables->leveldata->profiles[1].migrationspeed/distancesq[a.a][a.b],s->populations[a.b].b);
                s->populations[a.a].b+=g;
                s->populations[a.b].b-=g;
            }
        }

        foreach (FamineData fd, slices[i-1]->famines)
        {
            s->populations[fd.city].a*=fd.rate;
            s->populations[fd.city].b*=fd.rate;
        }

        //take into account population growth
        for (int j=0;j<citycount;j++)
        {
            float f = min(s->populations[j].a,-global_variables->leveldata->profiles[1].aggression*s->populations[j].b);
            float g = min(s->populations[j].b,-global_variables->leveldata->profiles[0].aggression*s->populations[j].a);
            s->populations[j].a-=s->populations[j].a*f;
            s->populations[j].b-=s->populations[j].b*g;

            s->populations[j].a*=global_variables->leveldata->profiles[0].mortality;
            s->populations[j].b*=global_variables->leveldata->profiles[1].mortality;
        }

        calcArrows(s->arrows,((float)i)/((float)SLICECOUNT));
        calcFamines(s->famines,((float)i)/((float)SLICECOUNT));

        float pop0=0;
        float pop1=0;
        for (int i=0;i<citycount;i++)
        {
            pop0+=s->populations[i].a;
            pop1+=s->populations[i].b;
        }
        s->totalpops.a=pop0;
        s->totalpops.b=pop1;

        slices.push_back(s);
    }

    widgets[4]->enabled=finished();
}

const bool MainPart::finished() const
{
    foreach(WinCondition wc,global_variables->leveldata->winconditions)
    {
        //city people condition amount
        if (wc.city>=0)//-1 means total population
        {
            if (wc.condition=="gt")
            {
                if (wc.people==1)
                {
                    if (!((int)(slices[SLICECOUNT]->populations[wc.city-1].a*1000000)>lrintf(wc.amount*1000000)))
                        return false;
                }
                else
                {
                    if (!((int)(slices[SLICECOUNT]->populations[wc.city-1].b*1000000)>lrintf(wc.amount*1000000)))
                        return false;
                }
            }
            else
            {
                if (wc.people==1)
                {
                    if (!((int)(slices[SLICECOUNT]->populations[wc.city-1].a*1000000)<lrintf(wc.amount*1000000)))
                        return false;
                }
                else
                {
                    if (!((int)(slices[SLICECOUNT]->populations[wc.city-1].b*1000000)<lrintf(wc.amount*1000000)))
                        return false;
                }
            }
        }
        else//do total population
        {
            float tp=0;

            if (wc.people==1)
            {
                for (int i=0;i<citycount;i++)
                    tp+=slices[SLICECOUNT]->populations[i].a;
            }
            else if (wc.people==2)
            {
                for (int i=0;i<citycount;i++)
                    tp+=slices[SLICECOUNT]->populations[i].b;
            }

            if (wc.condition=="gt")
            {
                if ((int)(tp*1000000)<lrintf(wc.amount*1000000))
                    return false;
            }
            else
            {
                if ((int)(tp*1000000)>lrintf(wc.amount*1000000))
                    return false;
            }
        }
    }

    return true;
}

void MainPart::populate()
{
    //step 1: copy from leveldata
    points.clear();
    startingpopulations.clear();

    startingpopulations=global_variables->leveldata->populations;
    points=global_variables->leveldata->cities;
    //step 2: copy into in-game variables

    citycount=points.size();
//    code for random generation
    /*
        for (int i = 0; i < citycount; i++)
        {
            Point p;
            p.x = rand() % PLAY_WIDTH;
            p.y = rand() % PLAY_HEIGHT;

            points.push_back(p);
            startingpopulations.push_back((Demographics)
            {
                (float)rand() / ((float)(RAND_MAX)+(float)(1)),
                (float)rand() / ((float)(RAND_MAX)+(float)(1))
            }
                                         );
        }*/

    distancesq.resize(extents[citycount][citycount]);
    for (int i=0;i<citycount;i++)
    {
        for (int j=0;j<citycount;j++)
        {
            float x=(points[i].x-points[j].x);
            float y=(points[i].y-points[j].y);
            distancesq[i][j]=x*x+y*y;
        }
    }
    populations=startingpopulations;
}


void MainPart::backupEvents()
{
    backups.push(events);
    widgets[8]->enabled=true;
}

void MainPart::undo()
{
    if (!backups.empty())
    {
        events=backups.top();
        backups.pop();
        if (backups.empty())
        {
            widgets[8]->enabled=false;
        }
    }

}

int MainPart::logic()
{
    switch (levelmode)
    {
    case lm_intro:
    {
        //empty
    }
    break;
    case lm_game:
    {
        //only contains widget-related listner
        if (newarrowmode!=arrowmode)
        {
            for (int i=0;i<3;i++)
            {
                arrowmode=newarrowmode;
                widgets[1+i]->on = (i)==arrowmode;
            }
        }
        if (showmenu==1)
        {
            setMenu();
        }
        if (submitparam==1)
        {
            highlighted=-1;
            highlightedarrow=-1;
            widgets[4]->enabled=false;
            levelmode=lm_playback;
            tooltip="Reviewing theory before submission - please stand by.";
            setTime(1);
        }
        if (doundo==1)
        {
            undo();
            calcArrows(arrows,time);
            calcFamines(famines,time);
            calcSlices();

            doundo=0;
        }
    }
    break;
    case lm_menu:
    {
        //should be empty
        if (menuparam==1)
        {
            widgets[0]->on=false;
            widgets[5]->enabled=false;
            widgets[6]->enabled=false;
            widgets[7]->enabled=false;
            levelmode=lm_game;
            calcSlices();//called again to enable 'submit thesis' button, if level auto-completed
        }
        else if (menuparam==2)
        {
            return 3;
        }
        else if (restartparam==1)
        {
            reset();
        }
    }
    break;
    case lm_playback:
    {
        //put playback stuff here!
        if (getTime()==0)
        {
            levelmode=lm_outro;
        }
        else
        {
            setTime(getTime()-1/(((float)FRAMES_PER_SECOND)*PLAYBACKTIME));
        }
    }
    break;
    case lm_outro:
    {
        //empty
    }
    break;

    }

    return 0;
}

void rect(GLfloat x1,GLfloat y1,GLfloat x2,GLfloat y2)
{
    glBegin(GL_LINE_LOOP);
    glVertex2f(x1,y1);
    glVertex2f(x2,y1);
    glVertex2f(x2,y2);
    glVertex2f(x1,y2);
    glEnd();
}

void filledrect(GLfloat x1,GLfloat y1,GLfloat x2,GLfloat y2)
{
    glBegin(GL_QUADS);
    glVertex2f(x1,y1);
    glVertex2f(x2,y1);
    glVertex2f(x2,y2);
    glVertex2f(x1,y2);
    glEnd();
}

void fastline(GLfloat x1,GLfloat y1,GLfloat x2,GLfloat y2)
{
    glBegin(GL_LINES);
    glVertex2f(x2,y2);
    //glColor3f(10.6f,0.8f,1.0f);
    glVertex2f(x1,y1);
    glEnd();
}

void gradline(GLfloat x1,GLfloat y1, GLfloat x2, GLfloat y2)
{
    glBegin(GL_LINES);
    glVertex2f(x2,y2);
    glColor4f(0.0f,0.0f,0.0f,0.0f);
    glVertex2f(x1,y1);
    glEnd();
    glColor4f(1.0f,1.0f,1.0f,1.0f);
}

bool inRect(float x, float y, float x1, float y1,float x2, float y2)
{
    return (x>=x1 && x<=x2 && y>=y1 && y<=y2);
}

void MainPart::draw()
{
    // glClearColor(10.6f,0.8f,1.0f,1.0f);
    glClearColor(0,0,0,1);
    glClear( GL_COLOR_BUFFER_BIT  );
    glDisable(GL_TEXTURE_2D);

    /* Move Into The Screen 5 Units */
    glLoadIdentity( );


    //code to draw the main area

    //if a city is highlighted
    if (highlighted >= 0)
    {
        glColor4f(0.6f,0.6f,0.3f,1.0f);
        rect( points[highlighted].x - 4*2, points[highlighted].y - 4*2, points[highlighted].x + 4*2, points[highlighted].y + 4*2);
    }


    foreach (FamineData fd, famines)
    {
        glColor4f(0.0f,0.3f,0.0f,1.0f);
        {
            filledrect( points[fd.city].x - 7*2, points[fd.city].y - 7*2, points[fd.city].x + 7*2, points[fd.city].y + 7*2);
        }
    }

    //draw the cities
    for (unsigned int i=0;i<points.size();i++)
    {
        glColor4f(1.0f,1.0f,1.0f,1.0f);
        fastline(points[i].x-4*1,points[i].y,points[i].x+4*1,points[i].y);
        glColor4f(1.0f,1.0f,1.0f,1.0f);
        fastline(points[i].x,points[i].y-4*1,points[i].x,points[i].y+4*1);
        glColor4f(0.1f,0.2f,0.4f,1.0f);
        rect( points[i].x - sqrt(populations[i].a)*4*8, points[i].y - sqrt(populations[i].a)*4*8, points[i].x + sqrt(populations[i].a)*4*8, points[i].y + sqrt(populations[i].a)*4*8);
        glColor4f(0.4f,0.2f,0.1f,1.0f);
        rect( points[i].x - sqrt(populations[i].b)*4*8, points[i].y - sqrt(populations[i].b)*4*8, points[i].x + sqrt(populations[i].b)*4*8, points[i].y + sqrt(populations[i].b)*4*8);

    }

    foreach(Arrow a, arrows)
    {
        switch (a.atype)
        {
        case at_both:
            glColor4f(0.6f,0.6f,0.6f,1.0f);
            break;
        case at_player:
            glColor4f(0.2f,0.2f,0.6f,1.0f);
            break;
        case at_enemy:
            glColor4f(0.6f,0.2f,0.2f,1.0f);
            break;
        case at_remove://SHOULD NEVER GET HERE
            break;
        }
        gradline( points[a.a].x, points[a.a].y, points[a.b].x, points[a.b].y);
    }



    switch (mousemode)
    {
    case mm_default:
    {
        if (highlightedarrow>=0)
        {
            glColor4f(0.6f,0.6f,0.9f,1.0f);
            fastline( points[arrows[highlightedarrow].a].x, points[arrows[highlightedarrow].a].y, points[arrows[highlightedarrow].b].x, points[arrows[highlightedarrow].b].y);
        }
    }
    break;
    case mm_dragpoint:
    {
        switch (arrowmode)
        {
        case at_both:
            glColor4f(0.6f,0.6f,0.6f,1.0f);
            break;
        case at_player:
            glColor4f(0.2f,0.2f,0.6f,1.0f);
            break;
        case at_enemy:
            glColor4f(0.6f,0.2f,0.2f,1.0f);
            break;
        case at_remove://SHOULD NEVER GET HERE
            break;
        }
        {
            if (highlighted >= 0)
            {
                gradline( points[dragsource].x, points[dragsource].y, points[highlighted].x, points[highlighted].y);
            }
            else
            {
                gradline( points[dragsource].x, points[dragsource].y, mx, my);
            }
        }
    }
    break;
    case mm_dragline:
    {
        if (highlightedarrow==draglineselected)
        {
            glColor4f(0.4f,0.4f,0.6f,1.0f);
            fastline( points[arrows[highlightedarrow].a].x, points[arrows[highlightedarrow].a].y, points[arrows[highlightedarrow].b].x, points[arrows[highlightedarrow].b].y);
        }
        else
        {
            glColor4f(0.7f,0.4f,0.4f,1.0f);
            fastline( points[arrows[draglineselected].a].x, points[arrows[draglineselected].a].y, points[arrows[draglineselected].b].x, points[arrows[draglineselected].b].y);
        }
    }
    break;
    }

//DRAW BOTTOM PANEL

//1: outlines

    glColor4f(0.5f,0.5f,1.0f,1.0f);
    rect(0,364,640,480);
    fastline(0,456,640,456);
    fastline(151,364,151,456);

    //frame for slider
    rect(157,370,634,424);

    //RIGHTMOST POINT IS 629; LEFTMOST POINT IS 167
    //orange box inside
    glColor4f(231.0f/255.0f,163.0f/255.0f,60.0f/255.0f,1.0f);
    //rect(162,375,629,419);

    float right=167.0f+getTime()*(629.0f-167.0f);
    rect(162.0f,375.0f, right,419.0f);
    fastline(right,364.0f,right,371.0f);
    fastline(right,423.0f,right,430.0f);

    //event markers

    foreach(Event e, events)
    {
        if (e.atype!=at_remove)
        {
            glColor4f(0.14f,0.85f,0.1f,1.0f);
        }
        else
        {
            glColor4f(0.58f,0.1f,0.85f,1.0f);
        }
        fastline( 167.0f+e.t*(629.0f-167.0f), 379,  167.0f+e.t*(629.0f-167.0f), 415);
    }

    glColor4f(0.0f,0.4f,0.0f,1.0f);
    foreach(Famine f,global_variables->leveldata->famines)
    {
        filledrect(167.0f+f.a*(629.0f-167.0f),(379.0f+415.0f)/2.0f-4.0f,167.0f+f.b*(629.0f-167.0f),(379.0f+415.0f)/2.0f+4.0f);
    }

    //draw the interval of existence for any thing
    if (highlightedarrow>=0)
    {
        glColor4f(0.8f,0.9f,1.0f,1.0f);

        fastline(167.0f+highlightedarrowbegin*(629.0f-167.0f),(379.0f+415.0f)/2.0f,167.0f+highlightedarrowend*(629.0f-167.0f),(379.0f+415.0f)/2.0f);
    }

    glColor4f(1.0f,1.0f,1.0f,1.0f);

    //text in frame
    graphicsengine->fontrenderer->glSmallPrint(156,480-440,"present",0);
    graphicsengine->fontrenderer->glSmallPrint(601,480-440,"past",0);

    //tooltip

    graphicsengine->fontrenderer->glSmallPrint(6,480-461-11,tooltip.c_str(),0);
//2 widgets


    glColor4f(1,1,1,1.0f);

    if (highlighted>=0)
    {
        bool foundfamine=false;
        foreach(FamineData fd, famines)
        {
            if (fd.city==highlighted)
            {
                foundfamine=true;
                break;
            }
        }
        if (!foundfamine)
        {
            glColor4f(1,1,1,1.0f);
            graphicsengine->fontrenderer->glSmallPrint(6,480-370-10,"City:",0);
        }
        else
        {
            glColor4f(0.1f,1.0f,0.1f,1.0f);
            graphicsengine->fontrenderer->glSmallPrint(6,480-370-10,"City (famine):",0);
        }

        graphicsengine->fontrenderer->glSmallPrintAlignRight(136,480-380-12,global_variables->leveldata->names[highlighted].c_str(),0);
        glColor4f(1,1,1,1.0f);
        graphicsengine->fontrenderer->glSmallPrint(6,480-390-17,"Population:",0);
        graphicsengine->fontrenderer->glSmallPrintNum(136,480-400-19,
                (int) ((populations[highlighted].a+populations[highlighted].b)*1000000)
                                                     );
        glColor4f(0,0,1,1.0f);
        graphicsengine->fontrenderer->glSmallPrintNum(136,480-410-19,
                (int) (populations[highlighted].a*1000000)
                                                     );
        glColor4f(1,0,0,1.0f);
        graphicsengine->fontrenderer->glSmallPrintNum(136,480-420-19,
                (int) (populations[highlighted].b*1000000)
                                                     );
        glColor4f(1,1,1,1.0f);
    }
    else if (highlightedarrow>=0)
    {
        bool foundfamine1=false;
        bool foundfamine2=false;
        foreach(FamineData fd, famines)
        {
            if (fd.city==arrows[highlightedarrow].a)
            {
                foundfamine1=true;
            }
            else if (fd.city==arrows[highlightedarrow].b)
            {
                foundfamine2=true;
            }
        }
        graphicsengine->fontrenderer->glSmallPrint(6,480-370-10,"Trail from",0);
        if (foundfamine1)
        {
            glColor4f(0.1f,1.0f,0.1f,1.0f);
            graphicsengine->fontrenderer->glSmallPrintAlignRight(136,480-380-14,global_variables->leveldata->names[arrows[highlightedarrow].a].c_str(),0);
            glColor4f(1,1,1,1.0f);
        }
        else
        {
            graphicsengine->fontrenderer->glSmallPrintAlignRight(136,480-380-14,global_variables->leveldata->names[arrows[highlightedarrow].a].c_str(),0);
        }
        graphicsengine->fontrenderer->glSmallPrint(6,480-390-16,"to",0);
        if (foundfamine2)
        {
            glColor4f(0.1f,1.0f,0.1f,1.0f);
            graphicsengine->fontrenderer->glSmallPrintAlignRight(136,480-400-18,global_variables->leveldata->names[arrows[highlightedarrow].b].c_str(),0);
            glColor4f(1,1,1,1.0f);
        }
        else
        {
            graphicsengine->fontrenderer->glSmallPrintAlignRight(136,480-400-18,global_variables->leveldata->names[arrows[highlightedarrow].b].c_str(),0);
        }

    }
    else if (levelmode!=lm_intro)//display total population
    {
        glColor4f(1,1,1,1.0f);
        graphicsengine->fontrenderer->glSmallPrint(6,480-370-10,"Overall",0);

        glColor4f(1,1,1,1.0f);
        graphicsengine->fontrenderer->glSmallPrint(6,480-390-17,"Population:",0);
        graphicsengine->fontrenderer->glSmallPrintNum(136,480-400-19,
                (int) ((totalpops.a+totalpops.b)*1000000)
                                                     );
        glColor4f(0,0,1,1.0f);
        graphicsengine->fontrenderer->glSmallPrintNum(136,480-410-19,
                (int) (totalpops.a*1000000)
                                                     );
        glColor4f(1,0,0,1.0f);
        graphicsengine->fontrenderer->glSmallPrintNum(136,480-420-19,
                (int) (totalpops.b*1000000)
                                                     );
        glColor4f(1,1,1,1.0f);
    }

    if (levelmode==lm_intro || levelmode==lm_outro)
    {
        tooltip="click to proceed";
        string text;
        int speaker;

        if (levelmode==lm_intro)
        {
            text = global_variables->leveldata->intro[cutscenemarker].dialogue;
            speaker = global_variables->leveldata->intro[cutscenemarker].speaker;
        }
        else//outro
        {
            text = global_variables->leveldata->outro[cutscenemarker].dialogue;
            speaker = global_variables->leveldata->outro[cutscenemarker].speaker;
        }


        int offx;
        int offy;

        if (global_variables->level!=19)
        {
            offx=146;
            offy=61;
            graphicsengine->drawpane(offx,offy,offx+279,offy+129);

            glColor4f(0.5f,0.5f,1.0f,1.0f);
            rect(offx+4,offy+4,offx+5+85+1,offy+5+119+1);
            glColor4f(1.0,1.0,1.0,1.0f);
            graphicsengine->iconrenderer->glAvatar(offx+5,480-offy-5-119,1);

            offx=251;
            offy=205;
            graphicsengine->drawpane(offx,offy,offx+279,offy+129);

            glColor4f(0.5f,0.5f,1.0f,1.0f);
            rect(offx+4,offy+4,offx+5+85+1,offy+5+119+1);
            glColor4f(1.0,1.0,1.0,1.0f);
            graphicsengine->iconrenderer->glAvatar(offx+5,480-offy-5-119,2);



            switch (speaker)
            {
            case 1:
                offx=146;
                offy=61;
                break;
            case 2:
                offx=251;
                offy=205;
                break;
            }

        }
        else
        {
            offx=185;
            offy=153;
            graphicsengine->drawpane(offx,offy,offx+279,offy+129);

            glColor4f(0.5f,0.5f,1.0f,1.0f);
            rect(offx+4,offy+4,offx+5+85+1,offy+5+119+1);
            glColor4f(0.0,0.0,1.0,1.0f);
            graphicsengine->iconrenderer->glAvatar(offx+5,480-offy-5-119,2);
            glColor4f(1.0,1.0,1.0,1.0f);



        }

        graphicsengine->fontrenderer->glSmallPrintMultiLine( offx+100,480-offy-10-8, 21, text.c_str(), 0 );

    }
    else if (levelmode==lm_menu)
    {
        tooltip="main menu";//when introduce widgets,do stuff here.

        //CONSTRUCT LEVEL OBJECTIVE
        string s;

        std::stringstream goalstring;
//        std::numpunct<char> *punct = new Punct;
//        const std::locale loc (std::cout.getloc (), punct);
//        goalstring.imbue(loc);

        goalstring <<"\n\n\n\nCONSTRAINTS AT TIME 0\n\n\n\n\n";

        foreach (WinCondition wc, global_variables->leveldata->winconditions)
        {
            if (wc.city>=0)
            {
                goalstring  << (wc.people==1?"Our population" :"The Others' population")
                << " in "
                << global_variables->leveldata->names[wc.city-1]
                << " should "
                << (wc.condition=="gt" ? "exceed " : "be less than ")
                << format_grouping(lrintf(wc.amount*1000000))
                << ".\n\n\n";
            }
            else
            {
                goalstring  << (wc.people==1?"Our total population should " :"The Others' total population should ")
                << (wc.condition=="gt" ? "exceed " : "be less than ")
                << format_grouping(lrintf(wc.amount*1000000))
                << ".\n\n\n";
            }
        }

        s = goalstring.str();

        graphicsengine->drawpane(136,38,132+382,38+280);
        glColor4f(1.0,1.0,1.0,1.0f);
        graphicsengine->fontrenderer->glSmallPrintMultiLine(136+5,480-38-10,45,s.c_str(),0);
    }


    //draw widgets (might appear in panel, so)
    for (unsigned int i=0;i<widgets.size();i++)
    {
        widgets[i]->draw();
    }

    //draw mouse cursor
    glColor4f(0.5f,0.5f,1.0f,1.0f);
    glBegin(GL_LINE_LOOP);
    glVertex2f(mx,my+4);
    glVertex2f(mx+4,my);
    glVertex2f(mx,my-4);
    glVertex2f(mx-4,my);
    glEnd();


    /*
    graphicsengine->iconrenderer->glIcon(0,100,0);
    graphicsengine->iconrenderer->glIcon(40,100,1);
    graphicsengine->iconrenderer->glIcon(80,100,2);
    graphicsengine->iconrenderer->glIcon(120,100,3);*/
//graphicsengine->g_fVBOSupported=false;
//     Set Pointers To Our Data
    /*
      glColor3f(1,0,0);

        if( graphicsengine->g_fVBOSupported )
        {
          glBindBufferARB( GL_ARRAY_BUFFER_ARB, graphicsengine->g_pMesh->m_nVBOVertices );
          glBindBufferARB(GL_ELEMENT_ARRAY_BUFFER_ARB, graphicsengine->g_pMesh->m_nVBOIndices);

          glEnableClientState(GL_VERTEX_ARRAY);

          glVertexPointer( 2, GL_FLOAT, 0, (char *) NULL );		// Set The Vertex Pointer To The Vertex Buffer

        //  glDrawElements(GL_LINES, graphicsengine->g_pMesh->indexcount, GL_UNSIGNED_INT, 0);

        } else
        {
          glEnableClientState(GL_VERTEX_ARRAY);
          glVertexPointer( 2, GL_FLOAT, 0, graphicsengine->g_pMesh->m_pVertices );	// Set The Vertex Pointer To Our Vertex Data
          glArrayElement(graphicsengine->g_pMesh->m_nVBOIndices);
        }
      // Render
          glDrawElements(GL_LINES, graphicsengine->g_pMesh->indexcount, GL_UNSIGNED_INT, 0);

          glDisableClientState(GL_VERTEX_ARRAY);*/

}
